Subject: Re: [PATCH net-next v3 2/3] net: phy: Add helper for getting tx amplitude gain

From: Dimitri Fedrau <[email-masked]>
Date: Thu, 6 Feb 2025 10:40:20 +0100

Am Wed, Feb 05, 2025 at 06:08:47PM +0100 schrieb Andrew Lunn:
> On Wed, Feb 05, 2025 at 06:22:18AM +0100, Dimitri Fedrau wrote:
> > Am Tue, Feb 04, 2025 at 05:54:53PM +0000 schrieb Russell King (Oracle):
> > > On Tue, Feb 04, 2025 at 02:09:16PM +0100, Dimitri Fedrau via B4 Relay wrote:
> > > >  #if IS_ENABLED(CONFIG_OF_MDIO)
> > > > -static int phy_get_int_delay_property(struct device *dev, const char *name)
> > > > +static int phy_get_u32_property(struct device *dev, const char *name)
> > > >  {
> > > >  	s32 int_delay;
> > > >  	int ret;
> > > > @@ -3108,7 +3108,7 @@ static int phy_get_int_delay_property(struct device *dev, const char *name)
> > > >  	return int_delay;
> > > 
> > > Hmm. You're changing the name of this function from "int" to "u32", yet
> > > it still returns "int".
> > >
> > 
> > I just wanted to reuse code for retrieving the u32, I found
> > phy_get_int_delay_property and renamed it. But the renaming from "int"
> > to "u32" is wrong as you outlined.
> > 
> > > What range of values are you expecting to be returned by this function?
> > > If it's the full range of u32 values, then that overlaps with the error
> > > range returned by device_property_read_u32().
> > >
> > 
> > Values are in percent, u8 would already be enough, so it wouldn't
> > overlap with the error range.
> > 
> > > I'm wondering whether it would be better to follow the example set by
> > > these device_* functions, and pass a pointer for the value to them, and
> > > just have the return value indicating success/failure.
> > >
> > 
> > I would prefer this, but this would mean changes in phy_get_internal_delay
> > if we don't want to duplicate code, as phy_get_internal_delay relies on
> > phy_get_int_delay_property and we change function parameters of
> > phy_get_int_delay_property as you described. I would switch from
> > static int phy_get_int_delay_property(struct device *dev, const char *name)
> > to
> > static int phy_get_u32_property(struct device *dev, const char *name, u32 *val)
> > 
> > Do you agree ?
> 
> This looks O.K. You should also rename the local variable int_delay.
> 
> Humm, that function has other issues.
> 
> static int phy_get_int_delay_property(struct device *dev, const char *name)
> {
> 	s32 int_delay;
> 	int ret;
> 
> 	ret = device_property_read_u32(dev, name, &int_delay);
> 	if (ret)
> 		return ret;
> 
> 	return int_delay;
> }
> 
> int_delay should really be a u32. if ret is not an error, there should
> be a range check to ensure int_long actually fits in an s32, otherwise
> -EINVAL, or maybe -ERANGE.
> 
> For delays, we never expect too much more than 2000ps, so no valid DT
> blob should trigger issues here.
> 
I think you mention this because you want to avoid changes in
phy_get_internal_delay because this would lead to changes in other
drivers too. Is it worth fixing this ? Then we didn't have to workaround by
checking if int_long actually fits in an s32.

Best regards,
Dimitri Fedrau